submodule--helper: offer a consistent API
[git/git.git] / git-submodule.sh
CommitLineData
70c7ac22
LH
1#!/bin/sh
2#
4c8a9db6 3# git-submodule.sh: add, init, update or list git submodules
70c7ac22
LH
4#
5# Copyright (c) 2007 Lars Hjemli
6
1d5bec8b 7dashless=$(basename "$0" | sed -e 's/-/ /')
681b036f 8USAGE="[--quiet] add [-b <branch>] [-f|--force] [--name <name>] [--reference <repository>] [--] <repository> [<path>]
64b19ffe 9 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
1d5bec8b 10 or: $dashless [--quiet] init [--] [<path>...]
f6a52799 11 or: $dashless [--quiet] deinit [-f|--force] (--all| [--] <path>...)
893a9764 12 or: $dashless [--quiet] update [--init] [--remote] [-N|--no-fetch] [-f|--force] [--checkout|--merge|--rebase] [--reference <repository>] [--recursive] [--] [<path>...]
adc54235 13 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
15fc56a8 14 or: $dashless [--quiet] foreach [--recursive] <command>
82f49f29 15 or: $dashless [--quiet] sync [--recursive] [--] [<path>...]"
8f321a39 16OPTIONS_SPEC=
091a6eb0 17SUBDIRECTORY_OK=Yes
70c7ac22 18. git-sh-setup
d0ad8251 19. git-sh-i18n
98fcf840 20. git-parse-remote
70c7ac22 21require_work_tree
091a6eb0
JK
22wt_prefix=$(git rev-parse --show-prefix)
23cd_to_toplevel
70c7ac22 24
33cfccbb
JK
25# Restrict ourselves to a vanilla subset of protocols; the URLs
26# we get are under control of a remote repository, and we do not
27# want them kicking off arbitrary git-remote-* programs.
28#
29# If the user has already specified a set of allowed protocols,
30# we assume they know what they're doing and use that instead.
31: ${GIT_ALLOW_PROTOCOL=file:git:http:https:ssh}
32export GIT_ALLOW_PROTOCOL
33
5c08dbbd 34command=
ecda0723 35branch=
d27b876b 36force=
d92a3959 37reference=
70c7ac22 38cached=
48bb3033
GP
39recursive=
40init=
1c244f6e 41files=
06b1abb5 42remote=
31ca3ac3 43nofetch=
32948425 44update=
15fc56a8 45prefix=
73b0898d 46custom_name=
275cd184 47depth=
70c7ac22 48
091a6eb0
JK
49# Resolve a path to be relative to another path. This is intended for
50# converting submodule paths when git-submodule is run in a subdirectory
51# and only handles paths where the directory separator is '/'.
52#
53# The output is the first argument as a path relative to the second argument,
54# which defaults to $wt_prefix if it is omitted.
55relative_path ()
56{
57 local target curdir result
58 target=$1
59 curdir=${2-$wt_prefix}
60 curdir=${curdir%/}
61 result=
62
63 while test -n "$curdir"
64 do
65 case "$target" in
66 "$curdir/"*)
67 target=${target#"$curdir"/}
68 break
69 ;;
70 esac
71
72 result="${result}../"
73 if test "$curdir" = "${curdir%/*}"
74 then
75 curdir=
76 else
77 curdir="${curdir%/*}"
78 fi
79 done
80
81 echo "$result$target"
82}
83
be9d0a3a
HV
84die_if_unmatched ()
85{
86 if test "$1" = "#unmatched"
87 then
88 exit 1
89 fi
90}
91
88ce00c3
TK
92#
93# Print a submodule configuration setting
94#
95# $1 = submodule name
96# $2 = option name
97# $3 = default value
98#
99# Checks in the usual git-config places first (for overrides),
100# otherwise it falls back on .gitmodules. This allows you to
101# distribute project-wide defaults in .gitmodules, while still
102# customizing individual repositories if necessary. If the option is
103# not in .gitmodules either, print a default value.
104#
105get_submodule_config () {
106 name="$1"
107 option="$2"
108 default="$3"
109 value=$(git config submodule."$name"."$option")
110 if test -z "$value"
111 then
112 value=$(git config -f .gitmodules submodule."$name"."$option")
113 fi
114 printf '%s' "${value:-$default}"
115}
116
862ae6cd
RS
117isnumber()
118{
119 n=$(($1 + 0)) 2>/dev/null && test "$n" = "$1"
120}
121
14111fc4
JK
122# Sanitize the local git environment for use within a submodule. We
123# can't simply use clear_local_git_env since we want to preserve some
124# of the settings from GIT_CONFIG_PARAMETERS.
125sanitize_submodule_env()
126{
89044baa 127 save_config=$GIT_CONFIG_PARAMETERS
14111fc4 128 clear_local_git_env
89044baa 129 GIT_CONFIG_PARAMETERS=$save_config
860cba61 130 export GIT_CONFIG_PARAMETERS
14111fc4
JK
131}
132
ecda0723
SV
133#
134# Add a new submodule to the working tree, .gitmodules and the index
135#
ec05df35 136# $@ = repo path
ecda0723
SV
137#
138# optional branch is stored in global branch variable
139#
23a485e3 140cmd_add()
ecda0723 141{
5c08dbbd 142 # parse $args after "submodule ... add".
091a6eb0 143 reference_path=
5c08dbbd
JH
144 while test $# -ne 0
145 do
146 case "$1" in
147 -b | --branch)
148 case "$2" in '') usage ;; esac
149 branch=$2
150 shift
151 ;;
d27b876b
JL
152 -f | --force)
153 force=$1
154 ;;
5c08dbbd 155 -q|--quiet)
2e6a30ef 156 GIT_QUIET=1
5c08dbbd 157 ;;
d92a3959
MT
158 --reference)
159 case "$2" in '') usage ;; esac
091a6eb0 160 reference_path=$2
d92a3959
MT
161 shift
162 ;;
163 --reference=*)
091a6eb0 164 reference_path="${1#--reference=}"
d92a3959 165 ;;
73b0898d
JL
166 --name)
167 case "$2" in '') usage ;; esac
168 custom_name=$2
169 shift
170 ;;
275cd184
FG
171 --depth)
172 case "$2" in '') usage ;; esac
173 depth="--depth=$2"
174 shift
175 ;;
176 --depth=*)
177 depth=$1
178 ;;
5c08dbbd
JH
179 --)
180 shift
181 break
182 ;;
183 -*)
184 usage
185 ;;
186 *)
187 break
188 ;;
189 esac
190 shift
191 done
192
091a6eb0
JK
193 if test -n "$reference_path"
194 then
195 is_absolute_path "$reference_path" ||
196 reference_path="$wt_prefix$reference_path"
197
198 reference="--reference=$reference_path"
199 fi
200
ecda0723 201 repo=$1
64394e3a 202 sm_path=$2
ecda0723 203
64394e3a 204 if test -z "$sm_path"; then
6a066230 205 sm_path=$(printf '%s\n' "$repo" |
1414e578
JL
206 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
207 fi
208
496eeeb1 209 if test -z "$repo" || test -z "$sm_path"; then
ecda0723
SV
210 usage
211 fi
212
091a6eb0
JK
213 is_absolute_path "$sm_path" || sm_path="$wt_prefix$sm_path"
214
ec05df35
ML
215 # assure repo is absolute or relative to parent
216 case "$repo" in
217 ./*|../*)
091a6eb0
JK
218 test -z "$wt_prefix" ||
219 die "$(gettext "Relative path can only be used from the toplevel of the working tree")"
220
ec05df35 221 # dereference source url relative to parent's url
63e95beb 222 realrepo=$(git submodule--helper resolve-relative-url "$repo") || exit
ec05df35
ML
223 ;;
224 *:*|/*)
225 # absolute url
226 realrepo=$repo
227 ;;
228 *)
497ee872 229 die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
ec05df35
ML
230 ;;
231 esac
232
db75ada5
MG
233 # normalize path:
234 # multiple //; leading ./; /./; /../; trailing /
64394e3a 235 sm_path=$(printf '%s/\n' "$sm_path" |
db75ada5
MG
236 sed -e '
237 s|//*|/|g
238 s|^\(\./\)*||
8196e728 239 s|/\(\./\)*|/|g
db75ada5
MG
240 :start
241 s|\([^/]*\)/\.\./||
242 tstart
243 s|/*$||
244 ')
64394e3a
RJ
245 git ls-files --error-unmatch "$sm_path" > /dev/null 2>&1 &&
246 die "$(eval_gettext "'\$sm_path' already exists in the index")"
ecda0723 247
64394e3a 248 if test -z "$force" && ! git add --dry-run --ignore-missing "$sm_path" > /dev/null 2>&1
d27b876b 249 then
6ff875c5 250 eval_gettextln "The following path is ignored by one of your .gitignore files:
64394e3a 251\$sm_path
6ff875c5 252Use -f if you really want to add it." >&2
d27b876b
JL
253 exit 1
254 fi
255
73b0898d
JL
256 if test -n "$custom_name"
257 then
258 sm_name="$custom_name"
259 else
260 sm_name="$sm_path"
261 fi
262
d4264ca3 263 # perhaps the path exists and is already a git repo, else clone it
64394e3a 264 if test -e "$sm_path"
d4264ca3 265 then
496eeeb1 266 if test -d "$sm_path"/.git || test -f "$sm_path"/.git
d4264ca3 267 then
64394e3a 268 eval_gettextln "Adding existing repo at '\$sm_path' to the index"
d4264ca3 269 else
64394e3a 270 die "$(eval_gettext "'\$sm_path' already exists and is not a valid git repo")"
d4264ca3 271 fi
c2f93917 272
d4264ca3 273 else
4b7c286e
JL
274 if test -d ".git/modules/$sm_name"
275 then
276 if test -z "$force"
277 then
278 echo >&2 "$(eval_gettext "A git directory for '\$sm_name' is found locally with remote(s):")"
279 GIT_DIR=".git/modules/$sm_name" GIT_WORK_TREE=. git remote -v | grep '(fetch)' | sed -e s,^," ", -e s,' (fetch)',, >&2
280 echo >&2 "$(eval_gettext "If you want to reuse this local git directory instead of cloning again from")"
281 echo >&2 " $realrepo"
282 echo >&2 "$(eval_gettext "use the '--force' option. If the local git directory is not the correct repo")"
283 die "$(eval_gettext "or you are unsure what this means choose another name with the '--name' option.")"
284 else
285 echo "$(eval_gettext "Reactivating local git directory for submodule '\$sm_name'.")"
286 fi
287 fi
d10e3b42 288 git submodule--helper clone ${GIT_QUIET:+--quiet} --prefix "$wt_prefix" --path "$sm_path" --name "$sm_name" --url "$realrepo" ${reference:+"$reference"} ${depth:+"$depth"} || exit
d851ffb9 289 (
14111fc4 290 sanitize_submodule_env
d851ffb9
JH
291 cd "$sm_path" &&
292 # ash fails to wordsplit ${branch:+-b "$branch"...}
293 case "$branch" in
294 '') git checkout -f -q ;;
295 ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
296 esac
297 ) || die "$(eval_gettext "Unable to checkout submodule '\$sm_path'")"
d4264ca3 298 fi
73b0898d 299 git config submodule."$sm_name".url "$realrepo"
d4264ca3 300
64394e3a
RJ
301 git add $force "$sm_path" ||
302 die "$(eval_gettext "Failed to add submodule '\$sm_path'")"
ecda0723 303
73b0898d
JL
304 git config -f .gitmodules submodule."$sm_name".path "$sm_path" &&
305 git config -f .gitmodules submodule."$sm_name".url "$repo" &&
b9289227
TK
306 if test -n "$branch"
307 then
308 git config -f .gitmodules submodule."$sm_name".branch "$branch"
309 fi &&
31991b02 310 git add --force .gitmodules ||
64394e3a 311 die "$(eval_gettext "Failed to register submodule '\$sm_path'")"
ecda0723
SV
312}
313
19a31f9c
ML
314#
315# Execute an arbitrary command sequence in each checked out
316# submodule
317#
318# $@ = command to execute
319#
320cmd_foreach()
321{
1d5bec8b
JH
322 # parse $args after "submodule ... foreach".
323 while test $# -ne 0
324 do
325 case "$1" in
326 -q|--quiet)
327 GIT_QUIET=1
328 ;;
15fc56a8
JH
329 --recursive)
330 recursive=1
331 ;;
1d5bec8b
JH
332 -*)
333 usage
334 ;;
335 *)
336 break
337 ;;
338 esac
339 shift
340 done
341
f030c96d
ÆAB
342 toplevel=$(pwd)
343
4dca1aa6
BC
344 # dup stdin so that it can be restored when running the external
345 # command in the subshell (and a recursive call to this function)
346 exec 3<&0
347
b0f4b408
SB
348 {
349 git submodule--helper list --prefix "$wt_prefix" ||
350 echo "#unmatched"
351 } |
64394e3a 352 while read mode sha1 stage sm_path
19a31f9c 353 do
be9d0a3a 354 die_if_unmatched "$mode"
64394e3a 355 if test -e "$sm_path"/.git
19a31f9c 356 then
ea2fa104
SB
357 displaypath=$(relative_path "$prefix$sm_path")
358 say "$(eval_gettext "Entering '\$displaypath'")"
0ea306ef 359 name=$(git submodule--helper name "$sm_path")
15fc56a8 360 (
64394e3a 361 prefix="$prefix$sm_path/"
14111fc4 362 sanitize_submodule_env
64394e3a 363 cd "$sm_path" &&
091a6eb0
JK
364 sm_path=$(relative_path "$sm_path") &&
365 # we make $path available to scripts ...
366 path=$sm_path &&
1c4fb136
AK
367 if test $# -eq 1
368 then
369 eval "$1"
370 else
371 "$@"
372 fi &&
15fc56a8
JH
373 if test -n "$recursive"
374 then
375 cmd_foreach "--recursive" "$@"
376 fi
4dca1aa6 377 ) <&3 3<&- ||
ea2fa104 378 die "$(eval_gettext "Stopping at '\$displaypath'; script returned non-zero status.")"
19a31f9c
ML
379 fi
380 done
381}
382
70c7ac22 383#
211b7f19 384# Register submodules in .git/config
70c7ac22
LH
385#
386# $@ = requested paths (default to all)
387#
23a485e3 388cmd_init()
70c7ac22 389{
5c08dbbd
JH
390 # parse $args after "submodule ... init".
391 while test $# -ne 0
392 do
393 case "$1" in
394 -q|--quiet)
2e6a30ef 395 GIT_QUIET=1
5c08dbbd
JH
396 ;;
397 --)
398 shift
399 break
400 ;;
401 -*)
402 usage
403 ;;
404 *)
405 break
406 ;;
407 esac
408 shift
409 done
410
3604242f 411 git ${wt_prefix:+-C "$wt_prefix"} submodule--helper init ${GIT_QUIET:+--quiet} ${prefix:+--prefix "$prefix"} "$@"
70c7ac22
LH
412}
413
cf419828
JL
414#
415# Unregister submodules from .git/config and remove their work tree
416#
417# $@ = requested paths (use '.' to deinit all submodules)
418#
419cmd_deinit()
420{
421 # parse $args after "submodule ... deinit".
f6a52799 422 deinit_all=
cf419828
JL
423 while test $# -ne 0
424 do
425 case "$1" in
426 -f|--force)
427 force=$1
428 ;;
429 -q|--quiet)
430 GIT_QUIET=1
431 ;;
f6a52799
SB
432 --all)
433 deinit_all=t
434 ;;
cf419828
JL
435 --)
436 shift
437 break
438 ;;
439 -*)
440 usage
441 ;;
442 *)
443 break
444 ;;
445 esac
446 shift
447 done
448
f6a52799
SB
449 if test -n "$deinit_all" && test "$#" -ne 0
450 then
451 echo >&2 "$(eval_gettext "pathspec and --all are incompatible")"
452 usage
453 fi
454 if test $# = 0 && test -z "$deinit_all"
cf419828 455 then
f6a52799 456 die "$(eval_gettext "Use '--all' if you really want to deinitialize all submodules")"
cf419828
JL
457 fi
458
b0f4b408
SB
459 {
460 git submodule--helper list --prefix "$wt_prefix" "$@" ||
461 echo "#unmatched"
462 } |
cf419828
JL
463 while read mode sha1 stage sm_path
464 do
465 die_if_unmatched "$mode"
0ea306ef 466 name=$(git submodule--helper name "$sm_path") || exit
cf419828 467
091a6eb0
JK
468 displaypath=$(relative_path "$sm_path")
469
cf419828
JL
470 # Remove the submodule work tree (unless the user already did it)
471 if test -d "$sm_path"
472 then
473 # Protect submodules containing a .git directory
474 if test -d "$sm_path/.git"
475 then
091a6eb0 476 echo >&2 "$(eval_gettext "Submodule work tree '\$displaypath' contains a .git directory")"
cf419828
JL
477 die "$(eval_gettext "(use 'rm -rf' if you really want to remove it including all of its history)")"
478 fi
479
480 if test -z "$force"
481 then
7b294bf4 482 git rm -qn "$sm_path" ||
091a6eb0 483 die "$(eval_gettext "Submodule work tree '\$displaypath' contains local modifications; use '-f' to discard them")"
cf419828 484 fi
7b294bf4 485 rm -rf "$sm_path" &&
091a6eb0
JK
486 say "$(eval_gettext "Cleared directory '\$displaypath'")" ||
487 say "$(eval_gettext "Could not remove submodule work tree '\$displaypath'")"
cf419828
JL
488 fi
489
091a6eb0 490 mkdir "$sm_path" || say "$(eval_gettext "Could not create empty submodule directory '\$displaypath'")"
cf419828
JL
491
492 # Remove the .git/config entries (unless the user already did it)
493 if test -n "$(git config --get-regexp submodule."$name\.")"
494 then
495 # Remove the whole section so we have a clean state when
496 # the user later decides to init this submodule again
497 url=$(git config submodule."$name".url)
498 git config --remove-section submodule."$name" 2>/dev/null &&
091a6eb0 499 say "$(eval_gettext "Submodule '\$name' (\$url) unregistered for path '\$displaypath'")"
cf419828
JL
500 fi
501 done
502}
503
fb43e31f 504is_tip_reachable () (
01e1d544 505 sanitize_submodule_env &&
fb43e31f
SB
506 cd "$1" &&
507 rev=$(git rev-list -n 1 "$2" --not --all 2>/dev/null) &&
508 test -z "$rev"
509)
510
511fetch_in_submodule () (
01e1d544 512 sanitize_submodule_env &&
fb43e31f
SB
513 cd "$1" &&
514 case "$2" in
515 '')
516 git fetch ;;
517 *)
518 git fetch $(get_default_remote) "$2" ;;
519 esac
520)
521
70c7ac22 522#
211b7f19 523# Update each submodule path to correct revision, using clone and checkout as needed
70c7ac22
LH
524#
525# $@ = requested paths (default to all)
526#
23a485e3 527cmd_update()
70c7ac22 528{
5c08dbbd
JH
529 # parse $args after "submodule ... update".
530 while test $# -ne 0
531 do
532 case "$1" in
533 -q|--quiet)
2e6a30ef 534 GIT_QUIET=1
5c08dbbd 535 ;;
be4d2c83 536 -i|--init)
d92a3959 537 init=1
be4d2c83 538 ;;
06b1abb5
TK
539 --remote)
540 remote=1
541 ;;
31ca3ac3 542 -N|--no-fetch)
31ca3ac3
FF
543 nofetch=1
544 ;;
9db31bdf
NMC
545 -f|--force)
546 force=$1
547 ;;
ca2cedba 548 -r|--rebase)
32948425 549 update="rebase"
ca2cedba 550 ;;
d92a3959
MT
551 --reference)
552 case "$2" in '') usage ;; esac
553 reference="--reference=$2"
98dbe63d 554 shift
d92a3959
MT
555 ;;
556 --reference=*)
557 reference="$1"
d92a3959 558 ;;
42b49178 559 -m|--merge)
42b49178
JH
560 update="merge"
561 ;;
b13fd5c1 562 --recursive)
b13fd5c1
JH
563 recursive=1
564 ;;
efc5fb6a
JH
565 --checkout)
566 update="checkout"
567 ;;
275cd184
FG
568 --depth)
569 case "$2" in '') usage ;; esac
570 depth="--depth=$2"
571 shift
572 ;;
573 --depth=*)
574 depth=$1
575 ;;
2335b870
SB
576 -j|--jobs)
577 case "$2" in '') usage ;; esac
578 jobs="--jobs=$2"
579 shift
580 ;;
581 --jobs=*)
582 jobs=$1
583 ;;
5c08dbbd
JH
584 --)
585 shift
586 break
587 ;;
588 -*)
589 usage
590 ;;
591 *)
592 break
593 ;;
594 esac
98dbe63d 595 shift
5c08dbbd
JH
596 done
597
d92a3959
MT
598 if test -n "$init"
599 then
600 cmd_init "--" "$@" || return
601 fi
602
48308681
SB
603 {
604 git submodule--helper update-clone ${GIT_QUIET:+--quiet} \
605 ${wt_prefix:+--prefix "$wt_prefix"} \
606 ${prefix:+--recursive-prefix "$prefix"} \
607 ${update:+--update "$update"} \
608 ${reference:+--reference "$reference"} \
609 ${depth:+--depth "$depth"} \
2335b870 610 ${jobs:+$jobs} \
48308681
SB
611 "$@" || echo "#unmatched"
612 } | {
15ffb7cd 613 err=
48308681 614 while read mode sha1 stage just_cloned sm_path
70c7ac22 615 do
be9d0a3a 616 die_if_unmatched "$mode"
48308681 617
0ea306ef 618 name=$(git submodule--helper name "$sm_path") || exit
5be60078 619 url=$(git config submodule."$name".url)
d851ffb9 620 branch=$(get_submodule_config "$name" branch master)
efc5fb6a
JH
621 if ! test -z "$update"
622 then
623 update_module=$update
624 else
625 update_module=$(git config submodule."$name".update)
a2aed08b
TK
626 if test -z "$update_module"
627 then
628 update_module="checkout"
629 fi
efc5fb6a
JH
630 fi
631
091a6eb0
JK
632 displaypath=$(relative_path "$prefix$sm_path")
633
48308681 634 if test $just_cloned -eq 1
d851ffb9 635 then
bf2d8246 636 subsha1=
48308681 637 update_module=checkout
bf2d8246 638 else
14111fc4 639 subsha1=$(sanitize_submodule_env; cd "$sm_path" &&
5be60078 640 git rev-parse --verify HEAD) ||
091a6eb0 641 die "$(eval_gettext "Unable to find current revision in submodule path '\$displaypath'")"
70c7ac22 642 fi
211b7f19 643
06b1abb5
TK
644 if test -n "$remote"
645 then
646 if test -z "$nofetch"
647 then
648 # Fetch remote before determining tracking $sha1
14111fc4 649 (sanitize_submodule_env; cd "$sm_path" && git-fetch) ||
06b1abb5
TK
650 die "$(eval_gettext "Unable to fetch in submodule path '\$sm_path'")"
651 fi
14111fc4
JK
652 remote_name=$(sanitize_submodule_env; cd "$sm_path" && get_default_remote)
653 sha1=$(sanitize_submodule_env; cd "$sm_path" &&
06b1abb5
TK
654 git rev-parse --verify "${remote_name}/${branch}") ||
655 die "$(eval_gettext "Unable to find current ${remote_name}/${branch} revision in submodule path '\$sm_path'")"
656 fi
657
496eeeb1 658 if test "$subsha1" != "$sha1" || test -n "$force"
70c7ac22 659 then
9db31bdf
NMC
660 subforce=$force
661 # If we don't already have a -f flag and the submodule has never been checked out
496eeeb1 662 if test -z "$subsha1" && test -z "$force"
b9b378a0 663 then
9db31bdf 664 subforce="-f"
b9b378a0 665 fi
31ca3ac3
FF
666
667 if test -z "$nofetch"
668 then
e5f522d6
JL
669 # Run fetch only if $sha1 isn't present or it
670 # is not reachable from a ref.
fb43e31f
SB
671 is_tip_reachable "$sm_path" "$sha1" ||
672 fetch_in_submodule "$sm_path" ||
091a6eb0 673 die "$(eval_gettext "Unable to fetch in submodule path '\$displaypath'")"
fb43e31f
SB
674
675 # Now we tried the usual fetch, but $sha1 may
676 # not be reachable from any of the refs
677 is_tip_reachable "$sm_path" "$sha1" ||
678 fetch_in_submodule "$sm_path" "$sha1" ||
679 die "$(eval_gettext "Fetched in submodule path '\$displaypath', but it did not contain $sha1. Direct fetching of that commit failed.")"
31ca3ac3
FF
680 fi
681
877449c1 682 must_die_on_failure=
32948425 683 case "$update_module" in
a2aed08b
TK
684 checkout)
685 command="git checkout $subforce -q"
686 die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$displaypath'")"
687 say_msg="$(eval_gettext "Submodule path '\$displaypath': checked out '\$sha1'")"
688 ;;
32948425
JH
689 rebase)
690 command="git rebase"
091a6eb0
JK
691 die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$displaypath'")"
692 say_msg="$(eval_gettext "Submodule path '\$displaypath': rebased into '\$sha1'")"
877449c1 693 must_die_on_failure=yes
32948425 694 ;;
42b49178
JH
695 merge)
696 command="git merge"
091a6eb0
JK
697 die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$displaypath'")"
698 say_msg="$(eval_gettext "Submodule path '\$displaypath': merged in '\$sha1'")"
877449c1 699 must_die_on_failure=yes
42b49178 700 ;;
6cb5728c
CP
701 !*)
702 command="${update_module#!}"
b08238ac
SB
703 die_msg="$(eval_gettext "Execution of '\$command \$sha1' failed in submodule path '\$displaypath'")"
704 say_msg="$(eval_gettext "Submodule path '\$displaypath': '\$command \$sha1'")"
6cb5728c
CP
705 must_die_on_failure=yes
706 ;;
32948425 707 *)
a2aed08b 708 die "$(eval_gettext "Invalid update mode '$update_module' for submodule '$name'")"
32948425 709 esac
70c7ac22 710
14111fc4 711 if (sanitize_submodule_env; cd "$sm_path" && $command "$sha1")
15ffb7cd 712 then
ff968f03 713 say "$say_msg"
877449c1
JH
714 elif test -n "$must_die_on_failure"
715 then
ff968f03 716 die_with_status 2 "$die_msg"
15ffb7cd 717 else
ff968f03 718 err="${err};$die_msg"
877449c1 719 continue
15ffb7cd 720 fi
70c7ac22 721 fi
b13fd5c1
JH
722
723 if test -n "$recursive"
724 then
75bf5e60 725 (
3604242f
SB
726 prefix=$(relative_path "$prefix$sm_path/")
727 wt_prefix=
14111fc4 728 sanitize_submodule_env
75bf5e60 729 cd "$sm_path" &&
36141282 730 eval cmd_update
75bf5e60 731 )
15ffb7cd
FG
732 res=$?
733 if test $res -gt 0
734 then
091a6eb0 735 die_msg="$(eval_gettext "Failed to recurse into submodule path '\$displaypath'")"
15ffb7cd
FG
736 if test $res -eq 1
737 then
ff968f03 738 err="${err};$die_msg"
15ffb7cd
FG
739 continue
740 else
ff968f03 741 die_with_status $res "$die_msg"
15ffb7cd
FG
742 fi
743 fi
b13fd5c1 744 fi
70c7ac22 745 done
15ffb7cd
FG
746
747 if test -n "$err"
748 then
749 OIFS=$IFS
750 IFS=';'
751 for e in $err
752 do
753 if test -n "$e"
754 then
755 echo >&2 "$e"
756 fi
757 done
758 IFS=$OIFS
759 exit 1
760 fi
761 }
70c7ac22
LH
762}
763
bffe71f4
EM
764set_name_rev () {
765 revname=$( (
14111fc4 766 sanitize_submodule_env
bffe71f4 767 cd "$1" && {
5be60078
JH
768 git describe "$2" 2>/dev/null ||
769 git describe --tags "$2" 2>/dev/null ||
f669ac0b
ML
770 git describe --contains "$2" 2>/dev/null ||
771 git describe --all --always "$2"
bffe71f4
EM
772 }
773 ) )
774 test -z "$revname" || revname=" ($revname)"
775}
28f9af5d
PY
776#
777# Show commit summary for submodules in index or working tree
778#
779# If '--cached' is given, show summary between index and given commit,
780# or between working tree and given commit
781#
782# $@ = [commit (default 'HEAD'),] requested paths (default all)
783#
784cmd_summary() {
f2dc06a3 785 summary_limit=-1
d0f64dd4 786 for_status=
1c244f6e 787 diff_cmd=diff-index
f2dc06a3 788
28f9af5d
PY
789 # parse $args after "submodule ... summary".
790 while test $# -ne 0
791 do
792 case "$1" in
793 --cached)
794 cached="$1"
795 ;;
1c244f6e
JL
796 --files)
797 files="$1"
798 ;;
d0f64dd4
PY
799 --for-status)
800 for_status="$1"
801 ;;
f2dc06a3 802 -n|--summary-limit)
862ae6cd
RS
803 summary_limit="$2"
804 isnumber "$summary_limit" || usage
f2dc06a3
PY
805 shift
806 ;;
862ae6cd
RS
807 --summary-limit=*)
808 summary_limit="${1#--summary-limit=}"
809 isnumber "$summary_limit" || usage
810 ;;
28f9af5d
PY
811 --)
812 shift
813 break
814 ;;
815 -*)
816 usage
817 ;;
818 *)
819 break
820 ;;
821 esac
822 shift
823 done
bffe71f4 824
f2dc06a3
PY
825 test $summary_limit = 0 && return
826
3deea89c 827 if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
28f9af5d
PY
828 then
829 head=$rev
caa9c3ca 830 test $# = 0 || shift
496eeeb1 831 elif test -z "$1" || test "$1" = "HEAD"
3deea89c 832 then
14e940d7
JH
833 # before the first commit: compare with an empty tree
834 head=$(git hash-object -w -t tree --stdin </dev/null)
2ea6c2c9 835 test -z "$1" || shift
28f9af5d 836 else
3deea89c 837 head="HEAD"
28f9af5d
PY
838 fi
839
1c244f6e
JL
840 if [ -n "$files" ]
841 then
842 test -n "$cached" &&
465d6a00 843 die "$(gettext "The --cached option cannot be used with the --files option")"
1c244f6e
JL
844 diff_cmd=diff-files
845 head=
846 fi
847
28f9af5d 848 cd_to_toplevel
091a6eb0 849 eval "set $(git rev-parse --sq --prefix "$wt_prefix" -- "$@")"
28f9af5d 850 # Get modified modules cared by user
18076502 851 modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
e1622bfc 852 sane_egrep '^:([0-7]* )?160000' |
2be94509 853 while read mod_src mod_dst sha1_src sha1_dst status sm_path
28f9af5d
PY
854 do
855 # Always show modules deleted or type-changed (blob<->module)
496eeeb1
EP
856 if test "$status" = D || test "$status" = T
857 then
6a066230 858 printf '%s\n' "$sm_path"
496eeeb1
EP
859 continue
860 fi
927b26f8 861 # Respect the ignore setting for --for-status.
862 if test -n "$for_status"
863 then
0ea306ef 864 name=$(git submodule--helper name "$sm_path")
927b26f8 865 ignore_config=$(get_submodule_config "$name" ignore none)
496eeeb1 866 test $status != A && test $ignore_config = all && continue
927b26f8 867 fi
28f9af5d 868 # Also show added or modified modules which are checked out
2be94509 869 GIT_DIR="$sm_path/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
6a066230 870 printf '%s\n' "$sm_path"
28f9af5d
PY
871 done
872 )
1cb639e6 873
d0f64dd4
PY
874 test -z "$modules" && return
875
18076502 876 git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
e1622bfc 877 sane_egrep '^:([0-7]* )?160000' |
1cb639e6
PY
878 cut -c2- |
879 while read mod_src mod_dst sha1_src sha1_dst status name
880 do
881 if test -z "$cached" &&
882 test $sha1_dst = 0000000000000000000000000000000000000000
883 then
884 case "$mod_dst" in
885 160000)
886 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
887 ;;
888 100644 | 100755 | 120000)
889 sha1_dst=$(git hash-object $name)
890 ;;
891 000000)
892 ;; # removed
893 *)
894 # unexpected type
6ff875c5 895 eval_gettextln "unexpected mode \$mod_dst" >&2
1cb639e6
PY
896 continue ;;
897 esac
898 fi
899 missing_src=
900 missing_dst=
901
902 test $mod_src = 160000 &&
30353a40 903 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_src^0 >/dev/null &&
1cb639e6
PY
904 missing_src=t
905
906 test $mod_dst = 160000 &&
30353a40 907 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_dst^0 >/dev/null &&
1cb639e6 908 missing_dst=t
bffe71f4 909
091a6eb0
JK
910 display_name=$(relative_path "$name")
911
1cb639e6
PY
912 total_commits=
913 case "$missing_src,$missing_dst" in
914 t,)
091a6eb0 915 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_src")"
1cb639e6
PY
916 ;;
917 ,t)
091a6eb0 918 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_dst")"
1cb639e6
PY
919 ;;
920 t,t)
091a6eb0 921 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commits \$sha1_src and \$sha1_dst")"
1cb639e6
PY
922 ;;
923 *)
924 errmsg=
925 total_commits=$(
496eeeb1 926 if test $mod_src = 160000 && test $mod_dst = 160000
1cb639e6
PY
927 then
928 range="$sha1_src...$sha1_dst"
929 elif test $mod_src = 160000
930 then
931 range=$sha1_src
932 else
933 range=$sha1_dst
934 fi
935 GIT_DIR="$name/.git" \
b0e621ad 936 git rev-list --first-parent $range -- | wc -l
1cb639e6 937 )
eed35595 938 total_commits=" ($(($total_commits + 0)))"
1cb639e6
PY
939 ;;
940 esac
941
942 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
943 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
944 if test $status = T
945 then
b3e73449
ÆAB
946 blob="$(gettext "blob")"
947 submodule="$(gettext "submodule")"
1cb639e6
PY
948 if test $mod_dst = 160000
949 then
091a6eb0 950 echo "* $display_name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
1cb639e6 951 else
091a6eb0 952 echo "* $display_name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
1cb639e6
PY
953 fi
954 else
091a6eb0 955 echo "* $display_name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
1cb639e6
PY
956 fi
957 if test -n "$errmsg"
958 then
959 # Don't give error msg for modification whose dst is not submodule
960 # i.e. deleted or changed to blob
961 test $mod_dst = 160000 && echo "$errmsg"
962 else
496eeeb1 963 if test $mod_src = 160000 && test $mod_dst = 160000
1cb639e6 964 then
f2dc06a3
PY
965 limit=
966 test $summary_limit -gt 0 && limit="-$summary_limit"
1cb639e6 967 GIT_DIR="$name/.git" \
f2dc06a3 968 git log $limit --pretty='format: %m %s' \
1cb639e6
PY
969 --first-parent $sha1_src...$sha1_dst
970 elif test $mod_dst = 160000
971 then
972 GIT_DIR="$name/.git" \
973 git log --pretty='format: > %s' -1 $sha1_dst
974 else
975 GIT_DIR="$name/.git" \
976 git log --pretty='format: < %s' -1 $sha1_src
977 fi
978 echo
979 fi
980 echo
3ba7407b 981 done
28f9af5d 982}
70c7ac22 983#
941987a5 984# List all submodules, prefixed with:
70c7ac22
LH
985# - submodule not initialized
986# + different revision checked out
987#
988# If --cached was specified the revision in the index will be printed
989# instead of the currently checked out revision.
990#
991# $@ = requested paths (default to all)
992#
23a485e3 993cmd_status()
70c7ac22 994{
5c08dbbd
JH
995 # parse $args after "submodule ... status".
996 while test $# -ne 0
997 do
998 case "$1" in
999 -q|--quiet)
2e6a30ef 1000 GIT_QUIET=1
5c08dbbd
JH
1001 ;;
1002 --cached)
1003 cached=1
1004 ;;
64b19ffe
JH
1005 --recursive)
1006 recursive=1
1007 ;;
5c08dbbd
JH
1008 --)
1009 shift
1010 break
1011 ;;
1012 -*)
1013 usage
1014 ;;
1015 *)
1016 break
1017 ;;
1018 esac
1019 shift
1020 done
1021
b0f4b408
SB
1022 {
1023 git submodule--helper list --prefix "$wt_prefix" "$@" ||
1024 echo "#unmatched"
1025 } |
64394e3a 1026 while read mode sha1 stage sm_path
70c7ac22 1027 do
be9d0a3a 1028 die_if_unmatched "$mode"
0ea306ef 1029 name=$(git submodule--helper name "$sm_path") || exit
5be60078 1030 url=$(git config submodule."$name".url)
091a6eb0 1031 displaypath=$(relative_path "$prefix$sm_path")
313ee0d6
NMC
1032 if test "$stage" = U
1033 then
1034 say "U$sha1 $displaypath"
1035 continue
1036 fi
496eeeb1
EP
1037 if test -z "$url" ||
1038 {
1039 ! test -d "$sm_path"/.git &&
1040 ! test -f "$sm_path"/.git
1041 }
70c7ac22 1042 then
64b19ffe 1043 say "-$sha1 $displaypath"
70c7ac22
LH
1044 continue;
1045 fi
64394e3a 1046 if git diff-files --ignore-submodules=dirty --quiet -- "$sm_path"
70c7ac22 1047 then
b545cd15 1048 set_name_rev "$sm_path" "$sha1"
64b19ffe 1049 say " $sha1 $displaypath$revname"
70c7ac22
LH
1050 else
1051 if test -z "$cached"
1052 then
14111fc4 1053 sha1=$(sanitize_submodule_env; cd "$sm_path" && git rev-parse --verify HEAD)
70c7ac22 1054 fi
b545cd15 1055 set_name_rev "$sm_path" "$sha1"
64b19ffe
JH
1056 say "+$sha1 $displaypath$revname"
1057 fi
1058
1059 if test -n "$recursive"
1060 then
1061 (
1062 prefix="$displaypath/"
14111fc4 1063 sanitize_submodule_env
10450cf7 1064 wt_prefix=
64394e3a 1065 cd "$sm_path" &&
e15bec0e 1066 eval cmd_status
64b19ffe 1067 ) ||
64394e3a 1068 die "$(eval_gettext "Failed to recurse into submodule path '\$sm_path'")"
70c7ac22
LH
1069 fi
1070 done
1071}
2327f61e
DA
1072#
1073# Sync remote urls for submodules
1074# This makes the value for remote.$remote.url match the value
1075# specified in .gitmodules.
1076#
1077cmd_sync()
1078{
1079 while test $# -ne 0
1080 do
1081 case "$1" in
1082 -q|--quiet)
2e6a30ef 1083 GIT_QUIET=1
2327f61e
DA
1084 shift
1085 ;;
82f49f29
PH
1086 --recursive)
1087 recursive=1
1088 shift
1089 ;;
2327f61e
DA
1090 --)
1091 shift
1092 break
1093 ;;
1094 -*)
1095 usage
1096 ;;
1097 *)
1098 break
1099 ;;
1100 esac
1101 done
1102 cd_to_toplevel
b0f4b408
SB
1103 {
1104 git submodule--helper list --prefix "$wt_prefix" "$@" ||
1105 echo "#unmatched"
1106 } |
64394e3a 1107 while read mode sha1 stage sm_path
2327f61e 1108 do
be9d0a3a 1109 die_if_unmatched "$mode"
0ea306ef 1110 name=$(git submodule--helper name "$sm_path")
2327f61e 1111 url=$(git config -f .gitmodules --get submodule."$name".url)
baede9f8
JH
1112
1113 # Possibly a url relative to parent
1114 case "$url" in
1115 ./*|../*)
967b2c66
JS
1116 # rewrite foo/bar as ../.. to find path from
1117 # submodule work tree to superproject work tree
6a066230 1118 up_path="$(printf '%s\n' "$sm_path" | sed "s/[^/][^/]*/../g")" &&
967b2c66
JS
1119 # guarantee a trailing /
1120 up_path=${up_path%/}/ &&
1121 # path from submodule work tree to submodule origin repo
63e95beb 1122 sub_origin_url=$(git submodule--helper resolve-relative-url "$url" "$up_path") &&
967b2c66 1123 # path from superproject work tree to submodule origin repo
63e95beb 1124 super_config_url=$(git submodule--helper resolve-relative-url "$url") || exit
967b2c66
JS
1125 ;;
1126 *)
1127 sub_origin_url="$url"
1128 super_config_url="$url"
baede9f8
JH
1129 ;;
1130 esac
1131
ccee6086 1132 if git config "submodule.$name.url" >/dev/null 2>/dev/null
2327f61e 1133 then
091a6eb0
JK
1134 displaypath=$(relative_path "$prefix$sm_path")
1135 say "$(eval_gettext "Synchronizing submodule url for '\$displaypath'")"
967b2c66 1136 git config submodule."$name".url "$super_config_url"
ccee6086 1137
64394e3a 1138 if test -e "$sm_path"/.git
ccee6086
JH
1139 then
1140 (
14111fc4 1141 sanitize_submodule_env
64394e3a 1142 cd "$sm_path"
ccee6086 1143 remote=$(get_default_remote)
967b2c66 1144 git config remote."$remote".url "$sub_origin_url"
82f49f29
PH
1145
1146 if test -n "$recursive"
1147 then
1148 prefix="$prefix$sm_path/"
1149 eval cmd_sync
1150 fi
ccee6086
JH
1151 )
1152 fi
2327f61e
DA
1153 fi
1154 done
1155}
70c7ac22 1156
5c08dbbd
JH
1157# This loop parses the command line arguments to find the
1158# subcommand name to dispatch. Parsing of the subcommand specific
1159# options are primarily done by the subcommand implementations.
1160# Subcommand specific options such as --branch and --cached are
1161# parsed here as well, for backward compatibility.
1162
1163while test $# != 0 && test -z "$command"
70c7ac22
LH
1164do
1165 case "$1" in
cf419828 1166 add | foreach | init | deinit | update | status | summary | sync)
5c08dbbd 1167 command=$1
70c7ac22
LH
1168 ;;
1169 -q|--quiet)
2e6a30ef 1170 GIT_QUIET=1
70c7ac22 1171 ;;
ecda0723
SV
1172 -b|--branch)
1173 case "$2" in
1174 '')
1175 usage
1176 ;;
1177 esac
1178 branch="$2"; shift
1179 ;;
70c7ac22 1180 --cached)
28f9af5d 1181 cached="$1"
70c7ac22
LH
1182 ;;
1183 --)
1184 break
1185 ;;
1186 -*)
1187 usage
1188 ;;
1189 *)
1190 break
1191 ;;
1192 esac
1193 shift
1194done
1195
5c08dbbd 1196# No command word defaults to "status"
af9c9f97
RR
1197if test -z "$command"
1198then
1199 if test $# = 0
1200 then
1201 command=status
1202 else
1203 usage
1204 fi
1205fi
5c08dbbd
JH
1206
1207# "-b branch" is accepted only by "add"
1208if test -n "$branch" && test "$command" != add
1209then
ecda0723 1210 usage
5c08dbbd
JH
1211fi
1212
28f9af5d 1213# "--cached" is accepted only by "status" and "summary"
496eeeb1 1214if test -n "$cached" && test "$command" != status && test "$command" != summary
5c08dbbd 1215then
70c7ac22 1216 usage
5c08dbbd
JH
1217fi
1218
1219"cmd_$command" "$@"